/***************************************************************/
/*                                                             */
/*  ERR.H                                                      */
/*                                                             */
/*  Error definitions.                                         */
/*                                                             */
/*  This file is part of REMIND.                               */
/*  Copyright (C) 1991 by David F. Skoll.                      */
/*                                                             */
/***************************************************************/

#define OK                    0
#define E_MISS_END            1
#define E_MISS_QUOTE          2
#define E_OP_STK_OVER         3
#define E_VA_STK_OVER         4
#define E_MISS_RIGHT_PAREN    5
#define E_UNDEF_FUNC          6
#define E_ILLEGAL_CHAR        7
#define E_EXPECTING_BINOP     8
#define E_NO_MEM              9
#define E_BAD_NUMBER         10
#define E_OP_STK_UNDER       11
#define E_VA_STK_UNDER       12
#define E_CANT_COERCE        13
#define E_BAD_TYPE           14
#define E_DATE_OVER          15
#define E_STACK_ERR          16
#define E_DIV_ZERO           17
#define E_NOSUCH_VAR         18
#define E_EOLN		     19
#define E_EOF		     20
#define E_IO_ERR             21
#define E_LINE_2_LONG        22
#define E_SWERR		     23
#define E_BAD_DATE           24
#define E_2FEW_ARGS	     25
#define E_2MANY_ARGS	     26
#define E_BAD_TIME	     27
#define E_2HIGH		     28
#define E_2LOW 		     29
#define E_CANT_OPEN          30
#define E_NESTED_INCLUDE     31
#define E_PARSE_ERR          32
#define E_CANT_TRIG          33
#define E_NESTED_IF          34
#define E_ELSE_NO_IF         35
#define E_ENDIF_NO_IF        36
#define E_2MANY_LOCALOMIT    37
#define E_EXTRANEOUS_TOKEN   38
#define E_POP_NO_PUSH        39
#define E_RUN_DISABLED       40
#define E_DOMAIN_ERR         41
#define E_BAD_ID             42
#define E_RECURSIVE          43
#define E_PARSE_AS_REM       44 /* Not really an error - just returned by
                                   DoOmit to indicate line should be executed
                                   as a REM statement, also. */
#ifdef MK_GLOBALS
#undef EXTERN
#define EXTERN
#else
#undef EXTERN
#define EXTERN extern
#endif

EXTERN char *ErrMsg[]

#ifdef MK_GLOBALS
= {
   "Ok",
   "Missing ']'",
   "Missing double-quote",
   "Expression too complex - too many operators",
   "Expression too complex - too many operands",
   "Missing ')'",
   "Undefined function",
   "Illegal character",
   "Expecting binary operator",
   "Out of memory",
   "Ill-formed number",
   "Op stack underflow - internal error",
   "Va stack underflow - internal error",
   "Can't coerce",
   "Type mismatch",
   "Date overflow",
   "Stack error - internal error",
   "Division by zero",
   "Undefined variable",
   "Unexpected end of line",
   "Unexpected end of file",
   "I/O error",
   "Line too long",
   "Internal error",
   "Bad date specification",
   "Not enough arguments",
   "Too many arguments",
   "Ill-formed time",
   "Number too high",
   "Number too low",
   "Can't open file",
   "INCLUDE nested too deeply",
   "Parse error",
   "Can't compute trigger",
   "Too many nested IFs",
   "ELSE with no matching IF",
   "ENDIF with no matching IF",
   "Can't OMIT every weekday",
   "Extraneous token(s) on line",
   "POP-OMIT-CONTEXT without matching PUSH-OMIT-CONTEXT",
   "RUN disabled",
   "Domain error",
   "Invalid identifier",
   "Recursive function call detected",
   ""
}
#endif
;
